;; Latin-2 specific utilityes for Mule.
;; Copyright (C) 1997 Free Software Foundation, Inc.
;; This file is part of Mule (MULtilingual Enhancement of GNU Emacs).
;; This file contains ISO8859-2 charcters.

;; Mule is free software distributed in the form of patches to GNU Emacs.
;; You can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 1, or (at your option)
;; any later version.

;; Mule is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; 97.3.1  modified for Mule Ver.2.3@19.30  by K.Fujii.
;;   Windows Latin-2 utilities.

(require 'primary)

(define-ccl-program ccl-read-windows-latin2
  '(3
    ((read r0)
     (loop
      (write-read-repeat
       r0
       [0   1   2   3   4   5   6   7   8   9   10  11  12  13  14  15
	16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31
	32  33  34  35  36  37  38  39  40  41  42  43  44  45  46  47
	48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63
	64  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79
	80  81  82  83  84  85  86  87  88  89  90  91  92  93  94  95
	96  97  98  99  100 101 102 103 104 105 106 107 108 109 110 111
	112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127
	32  32  32  32  32  32  32  32  32  32  ?,B)(B  32  ?,B&(B  ?,B+(B  ?,B.(B  ?,B,(B
	32  32  32  32  32  32  32  32  32  32  ?,B9(B  32  ?,B6(B  ?,B;(B  ?,B>(B  ?,B<(B
	32  32  32  ?,B#(B  32  ?,B!(B  124 32  32  32  ?,B*(B  32  32  32  32  ?,B/(B
	32  32  32  ?,B3(B  32  32  32  32  32  ?,B1(B  ?,B:(B  32  ?,BE(B  32  ?,Be(B  ?,B?(B
	?,B@(B  ?,BA(B  ?,BB(B  ?,BC(B  32  ?,BE(B  ?,BF(B  ?,BG(B  ?,BH(B  ?,BI(B  ?,BJ(B  ?,BK(B  ?,BL(B  ?,BM(B  ?,BN(B  ?,BO(B
	?,BP(B  ?,BQ(B  ?,BR(B  ?,BS(B  ?,BT(B  ?,BU(B  ?,BV(B  ?,BW(B  ?,BX(B  ?,BY(B  ?,BZ(B  ?,B[(B  ?,B\(B  ?,B](B  ?,B^(B  ?,B_(B
	?,B`(B  ?,Ba(B  ?,Bb(B  ?,Bc(B  ?,Bd(B  ?,Be(B  ?,Bf(B  ?,Bg(B  ?,Bh(B  ?,Bi(B  ?,Bj(B  ?,Bk(B  ?,Bl(B  ?,Bm(B  ?,Bn(B  ?,Bo(B
	?,Bp(B  ?,Bq(B  ?,Br(B  ?,Bs(B  ?,Bt(B  ?,Bu(B  ?,Bv(B  ?,Bw(B  ?,Bx(B  ?,By(B  ?,Bz(B  ?,B{(B  ?,B|(B  ?,B}(B  ?,B~(B  32]))))
  "CCL program to read Windows Latin-2.")

(define-ccl-program ccl-write-windows-latin2
  '(1
    ((read r0)
     (loop
      (if (r0 != 130)			; lc-ltn2 == 130
	  (write-read-repeat r0)
	((read r0)
	 (r0 -= 160)
	 (write-read-repeat
	  r0
	  [32  165 162 163 164 188 140 167 168 138 170 141 143 150 142 175
	   176 185 178 179 180 190 156 162 130 154 186 157 159 148 158 191
	   192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207
	   208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223
	   224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239
	   240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255]))))))
  "CCL program to write Windows Latin-2.")

(make-coding-system
 '*win-latin2* 4
 ?2 "Coding-system used Windows Latin-2."
 2
 (cons ccl-read-windows-latin2 ccl-write-windows-latin2))

(defun set-latin2-environment-windows-latin2 ()
  "Make Windows Latin-2 the default charcter set for Latin-2."
  (setq *coding-catrgory-iso-8-1* '*win-latin2*)

  (set-coding-priority
   '(*coding-category-iso-8-1*
     *coding-category-iso-8-2*))

  (set-default-file-coding-system '*win-latin2*)
  (set-file-coding-systen '*win-latin2*)
  (set-display-coding-system '*win-latin2*)

  (setq-default quail-current-package (assoc "latin-2" quail-package-alist)))

(put 'win-latin2 'primary-function 'set-latin2-environment-windows-latin2)

(setq *modify-file-coding-system-for-read-alist*
      (append *modify-file-coding-system-for-read-alist*
	      '((win-latin2 . *win-latin2*))))

(provide 'easteurope)
