;; modify set-primary-environment for Windows-Latin2, Windows-Cyrillic and Code Page.
;; Copyright (C) 1997 Free Software Foundation, Inc.
;; This file is part of Mule (MULtilingual Enhancement of GNU Emacs).
;; This file contains ISO8859-2 charcters.

;; Mule is free software distributed in the form of patches to GNU Emacs.
;; You can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 1, or (at your option)
;; any later version.

;; Mule is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; 97.3.10  K.Fujii <JAE01012@niftyserve.or.jp>.

(or (fboundp 'si:set-primary-environment)
    (fset 'si:set-primary-environment
	  (symbol-function 'set-primary-environment)))

(defvar *modify-file-coding-system-for-read-alist* nil)
(defvar *save-file-coding-system-for-read* nil)

(defun set-primary-environment (env)
  "Set ENVIRONMENT (e.g. 'japanese, 'cp-850) as the primary one."
  (interactive
   (list (intern (completing-read "Primary environment (language) ? "
				  obarray 'environmentp 'require-match))))
  (let* ((v (si:set-primary-environment env))
	 (alist *modify-file-coding-system-for-read-alist*)
	 coding-system)
    (while (and alist
		(not (eq env (car (car alist)))))
      (setq alist (cdr alist)))
    (and alist
	 (setq coding-system (cdr (car alist))))
    (if (and (not (non-nil-coding-system-p coding-system))
	     (non-nil-coding-system-p *save-file-coding-system-for-read*))
	(progn
	  (set-file-coding-system-for-read *save-file-coding-system-for-read*)
	  (setq *save-file-coding-system-for-read* nil))
      (if (non-nil-coding-system-p coding-system)
	  (progn
	    (and (not (non-nil-coding-system-p
		       *save-file-coding-system-for-read*))
		 (setq *save-file-coding-system-for-read*
		       file-coding-system-for-read))
	    (set-file-coding-system-for-read coding-system))))
    v))

(provide 'primary)
